import java.util.LinkedList;

public class BaseParser {
    private LinkedList<String> tokens;
    public BaseParser(BaseLexer lexer) {
        tokens = new LinkedList<String>();
        String token;
        while ((token = lexer.nextToken()) != null) {
            tokens.add(token);
        }
    }
    public String lookAhead(int dist) {
        return (0 < dist && dist <= tokens.size()) ? tokens.get(dist - 1) : null;
    }
    public void readToken() {
        tokens.remove();
    }
}
