public class Lexer implements BaseLexer {
    private String source;
    private int tokenBeginPosition = 0;
    private int tokenEndPosition = 0;

    public Lexer(String source) {
        this.source = source;
    }
    public String nextToken() {
        tokenBeginPosition = tokenEndPosition;
        while (tokenBeginPosition < source.length()) {
            char nxt = '\0';
            while (tokenBeginPosition < source.length() && ((nxt = source.charAt(tokenBeginPosition)) == ' ' || nxt == '\n')) {
                ++tokenBeginPosition;
            }
            if (tokenBeginPosition >= source.length()) {
                break;
            }
            tokenEndPosition = tokenBeginPosition + 1;
            if (nxt == '+' || nxt == '*') {
                return source.substring(tokenBeginPosition, tokenEndPosition);
            } else if ('0' <= nxt && nxt <= '9') {
                while (tokenEndPosition < source.length() && '0' <= (nxt = source.charAt(tokenEndPosition)) && nxt <= '9') {
                    ++tokenEndPosition;
                }
                return source.substring(tokenBeginPosition, tokenEndPosition);
            } else {
                System.err.println("Skipping invalid token at " + tokenBeginPosition + ": '" + source.substring(tokenBeginPosition, tokenEndPosition) + "'");
                tokenBeginPosition = tokenEndPosition;
                continue;
            }
        }
        return null;
    }
}
